package ru.dbotthepony.kstarbound.defs.`object`

import com.google.common.collect.ImmutableList
import com.google.common.collect.ImmutableSet
import ru.dbotthepony.kstarbound.defs.AssetPath
import ru.dbotthepony.kstarbound.defs.AssetReference
import ru.dbotthepony.kstarbound.defs.ItemReference
import ru.dbotthepony.kstarbound.defs.RegistryReference
import ru.dbotthepony.kstarbound.defs.animation.AnimationDefinition
import ru.dbotthepony.kstarbound.defs.item.TreasurePoolDefinition
import ru.dbotthepony.kstarbound.io.json.builder.JsonFactory

/**
 * Concrete (final) values of in-world object
 */
@JsonFactory(logMisses = false)
data class ObjectDefinition(
	val objectName: String,
	val objectType: ObjectType = ObjectType.OBJECT,
	val race: String = "generic",
	val category: String = "other",
	val colonyTags: ImmutableSet<String> = ImmutableSet.of(),

	val scripts: ImmutableSet<AssetPath> = ImmutableSet.of(),
	val animationScripts: ImmutableSet<AssetPath> = ImmutableSet.of(),

	val hasObjectItem: Boolean = true,
	val scannable: Boolean = true,
	val printable: Boolean = true,
	val retainObjectParametersInItem: Boolean = false,

	val breakDropPool: RegistryReference<TreasurePoolDefinition>? = null,
	val smashDropOptions: ImmutableList<ImmutableList<ItemReference>> = ImmutableList.of(),

	val animation: AssetReference<AnimationDefinition>? = null,
)
